// Copyright 2006 all rights reserved; see LICENSE file for BSD-style license

package edu.berkeley.sbp;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;
import java.lang.ref.*;
import edu.berkeley.sbp.util.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.*;

/**
 *  <font color=green>an element which matches some set of one-token-long input strings</font>.
 *
 *  <p>
 *  This class is a topology over itself (yes, that's sort of <a
 *  href=http://en.wikipedia.org/wiki/Frege>Frege'd</a> up) so that
 *  Atoms can be intersected and unioned with each other to result in
 *  other Atom<Token>'s (rather than raw Topology<Token>'s, which are
 *  not Elements).  If you want the latter, use the getTokenTopology()
 *  method.
 *  </p>
 */
public abstract class Atom<Token> extends Element implements Topology<Atom<Token>> {

    /** the set (topology) of tokens that can match this element */
    public abstract Topology<Token>  getTokenTopology();

    StringBuffer toString(StringBuffer sb) { sb.append(this); return sb; }

}


